local addonname = ...
local addon = CreateFrame("Frame")
_G[addonname] = addon
addon.name = addonname
addon:SetScript("OnEvent", function(self, event, ...)
	local args={...}
	if event == "ADDON_LOADED" and args[1] == self.name then
		SavedCombatLogFilterSettings = SavedCombatLogFilterSettings or {}
		self.sVar = SavedCombatLogFilterSettings
	end
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if not self.sVar then return end
		for _, fdata in pairs(self.sVar) do
			local isFalse
			for argNum, value in pairs(fdata) do
				if type(value) == "string" and type(args[argNum]) == "string" then
					if not (args[argNum]:match(value) == args[argNum]) then
						isFalse = true
						break
					end
				else
					if not (args[argNum] == value) then
						isFalse = true
						break
					end
				end
			end
			if not isFalse then
				print("Combat log matched: ", unpack(args))
			end
		end
	end
end)
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
SlashCmdList["CLOGFILTER"]=function(input)
	local cmd = input:match("%S+")
	if cmd == "list" then
		print("Combat log filter listing")
		for num, filterList in ipairs(addon.sVar) do
			local lString = ""
			for arg, value in pairs(filterList) do
				lString = lString..(strlen(lString)>0 and " " or "")..arg.."="..(type(value) == "string" and "\""..value.."\"" or value)
			end
			print("Filter #"..num, lString)
		end
	elseif cmd == "remove" then
		local key = tonumber(input:match("%d+"))
		if addon.sVar[key] then
			local lString=""
			for arg, value in pairs(addon.sVar[key]) do
				lString = lString..(strlen(lString)>0 and " " or "")..arg.."="..(type(value) == "string" and "\""..value.."\"" or value)
			end
			tremove(addon.sVar,key)
			print("Filter #"..key.." ("..lString..") deleted")
		end
	elseif cmd == "add" then
		local filterString = input:match("%S+(.+)")
		local hasFilter = false
		local this_t = {}
		for argString in input:gmatch("(%d+%=%\".-%\")") do
			local arg, stringpt = argString:match("(%d+)%=%\"(.-)%\"")
			arg = tonumber(arg)
			this_t[arg] = stringpt
			hasFilter = true
		end
		for argNum in input:gmatch("(%d+%=%d+)") do
			local arg, num = argNum:match("(%d+)%=(%d+)")
			arg, num = tonumber(arg), tonumber(num)
			this_t[arg] = num
			hasFilter = true
		end
		if hasFilter then
			local lString=""
			for arg, value in pairs(this_t) do
				lString = lString..(strlen(lString)>0 and " " or "")..arg.."="..(type(value) == "string" and "\""..value.."\"" or value)
			end
			tinsert(addon.sVar, this_t)
			print("Filter #"..(#addon.sVar).." created: "..lString)
		end
	end
end
SLASH_CLOGFILTER1 = "/clogfilter"